gtkmm: Gtk::GestureLongPress Class Reference

gtkmm 4.23.2

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::GestureLongPress Class Reference
Event Controllers and Gestures

"Press and Hold" gesture. More...

`#include <gtkmm/gesturelongpress.h>`

Inheritance diagram for Gtk::GestureLongPress:
[legend]

## Public Member Functions
| GestureLongPress (GestureLongPress && src) noexcept
GestureLongPress & | operator= (GestureLongPress && src) noexcept
| ~GestureLongPress () noexcept override
GtkGestureLongPress * | gobj ()
| Provides access to the underlying C GObject.
const GtkGestureLongPress * | gobj () const
| Provides access to the underlying C GObject.
GtkGestureLongPress * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_delay_factor (double delay_factor)
| Applies the given delay factor.
double | get_delay_factor () const
| Returns the delay factor.
Glib::SignalProxy< void(double, double)> | signal_pressed ()
Glib::SignalProxy< void()> | signal_cancelled ()
Glib::PropertyProxy< double > | property_delay_factor ()
| Factor by which to modify the default timeout.
Glib::PropertyProxy_ReadOnly< double > | property_delay_factor () const
| Factor by which to modify the default timeout.
Public Member Functions inherited from Gtk::GestureSingle
| GestureSingle (GestureSingle && src) noexcept
GestureSingle & | operator= (GestureSingle && src) noexcept
| ~GestureSingle () noexcept override
GtkGestureSingle * | gobj ()
| Provides access to the underlying C GObject.
const GtkGestureSingle * | gobj () const
| Provides access to the underlying C GObject.
GtkGestureSingle * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | get_touch_only () const
| Returns true if the gesture is only triggered by touch events.
void | set_touch_only (bool touch_only=true)
| Sets whether to handle only touch events.
bool | get_exclusive () const
| Gets whether a gesture is exclusive.
void | set_exclusive (bool exclusive=true) const
| Sets whether gesture is exclusive.
unsigned int | get_button () const
| Returns the button number gesture listens for.
void | set_button (unsigned int button=0)
| Sets the button number gesture listens to.
unsigned int | get_current_button () const
| Returns the button number currently interacting with gesture, or 0 if there is none.
Gdk::EventSequence * | get_current_sequence ()
| Returns the event sequence currently interacting with gesture.
const Gdk::EventSequence * | get_current_sequence () const
| Returns the event sequence currently interacting with gesture.
Glib::PropertyProxy< bool > | property_touch_only ()
| Whether the gesture handles only touch events.
Glib::PropertyProxy_ReadOnly< bool > | property_touch_only () const
| Whether the gesture handles only touch events.
Glib::PropertyProxy< bool > | property_exclusive ()
| Whether the gesture is exclusive.
Glib::PropertyProxy_ReadOnly< bool > | property_exclusive () const
| Whether the gesture is exclusive.
Glib::PropertyProxy< unsigned int > | property_button ()
| Mouse button number to listen to, or 0 to listen for any button.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_button () const
| Mouse button number to listen to, or 0 to listen for any button.
Public Member Functions inherited from Gtk::Gesture
| Gesture (Gesture && src) noexcept
Gesture & | operator= (Gesture && src) noexcept
| ~Gesture () noexcept override
GtkGesture * | gobj ()
| Provides access to the underlying C GObject.
const GtkGesture * | gobj () const
| Provides access to the underlying C GObject.
GtkGesture * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the logical Gdk::Device that is currently operating on gesture.
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the logical Gdk::Device that is currently operating on gesture.
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with.
EventSequenceState | get_sequence_state (Gdk::EventSequence * sequence) const
| Returns the sequence state, as seen by gesture.
bool | set_sequence_state (Gdk::EventSequence * sequence, EventSequenceState state)
| Sets the state of sequence in gesture.
std::vector< const Gdk::EventSequence * > | get_sequences () const
| Returns the list of Gdk::EventSequences currently being interpreted.
Gdk::EventSequence * | get_last_updated_sequence ()
| Returns the Gdk::EventSequence that was last updated on gesture.
const Gdk::EventSequence * | get_last_updated_sequence () const
| Returns the Gdk::EventSequence that was last updated on gesture.
bool | handles_sequence (Gdk::EventSequence * sequence) const
| Returns true if gesture is currently handling events corresponding to sequence.
Glib::RefPtr< Gdk::Event > | get_last_event (Gdk::EventSequence * sequence)
| Returns the last event that was processed for sequence.
Glib::RefPtr< const Gdk::Event > | get_last_event (Gdk::EventSequence * sequence) const
| Returns the last event that was processed for sequence.
bool | get_point (Gdk::EventSequence * sequence, double & x, double & y) const
| If sequence is currently being interpreted by gesture, returns true and fills in x and y with the last coordinates stored for that event sequence.
bool | get_bounding_box (Gdk::Rectangle & rect) const
| If there are touch sequences being currently handled by gesture, returns true and fills in rect with the bounding box containing all active touches.
bool | get_bounding_box_center (double & x, double & y) const
| If there are touch sequences being currently handled by gesture, returns true and fills in x and y with the center of the bounding box containing all active touches.
bool | is_active () const
| Returns true if the gesture is currently active.
bool | is_recognized () const
| Returns true if the gesture is currently recognized.
void | group (const Glib::RefPtr< Gesture > & group_gesture)
| Adds gesture to the same group than group_gesture.
void | ungroup ()
| Separates gesture into an isolated group.
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture.
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture.
bool | is_grouped_with (const Glib::RefPtr< Gesture > & other) const
| Returns true if both gestures pertain to the same group.
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_begin ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_end ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_update ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_cancel ()
Glib::SignalProxy< void(Gdk::EventSequence *, EventSequenceState)> | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture.
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject.
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Widget * | get_widget ()
| Returns the Gtk::Widget this controller relates to.
const Widget * | get_widget () const
| Returns the Gtk::Widget this controller relates to.
void | reset ()
| Resets the controller to a clean state.
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events.
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events.
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller.
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller.
Glib::ustring | get_name () const
| Gets the name of controller.
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging.
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller.
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller.
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller.
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller.
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller.
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle.
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle.
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle.
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< GestureLongPress > | create ()
| Creates a Gesture that recognizes long presses.
Static Public Member Functions inherited from Gtk::GestureSingle
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Gesture
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| GestureLongPress ()
| Constructs a Gesture that recognizes long presses.
Protected Member Functions inherited from Gtk::GestureSingle
| GestureSingle ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Gtk::Gesture
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::GestureLongPress > | wrap (GtkGestureLongPress * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::GestureSingle
Glib::RefPtr< Gtk::GestureSingle > | wrap (GtkGestureSingle * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Gesture
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

"Press and Hold" gesture.

This is a Gesture implementation able to recognize long presses, triggering signal_pressed() after the timeout is exceeded.

If the touchpoint is lifted before the timeout passes, or if it drifts too far of the initial press point, signal_cancelled() will be emitted.

Since gtkmm 3.14

## Constructor & Destructor Documentation

## ◆ GestureLongPress() [1/2]

Gtk::GestureLongPress::GestureLongPress | ( | GestureLongPress && | src | ) |
| noexcept

## ◆ ~GestureLongPress()

Gtk::GestureLongPress::~GestureLongPress | ( |  | ) |
| overridenoexcept

## ◆ GestureLongPress() [2/2]

Gtk::GestureLongPress::GestureLongPress | ( |  | ) |
| protected

Constructs a Gesture that recognizes long presses.

## Member Function Documentation

## ◆ create()

Glib::RefPtr< GestureLongPress > Gtk::GestureLongPress::create | ( |  | ) |
| static

Creates a Gesture that recognizes long presses.

Since gtkmm 3.14

Returns
  A RefPtr to a new GestureLongPress.

## ◆ get_delay_factor()

double Gtk::GestureLongPress::get_delay_factor | ( |  | ) | const

Returns the delay factor.

Returns
  The delay factor.

## ◆ get_type()

GType Gtk::GestureLongPress::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkGestureLongPress * Gtk::GestureLongPress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkGestureLongPress * Gtk::GestureLongPress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkGestureLongPress * Gtk::GestureLongPress::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

GestureLongPress & Gtk::GestureLongPress::operator= | ( | GestureLongPress && | src | ) |
| noexcept

## ◆ property_delay_factor() [1/2]

Glib::PropertyProxy< double > Gtk::GestureLongPress::property_delay_factor | ( |  | ) |

Factor by which to modify the default timeout.

Since gtkmm 3.20

Default value: 1.000000

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_delay_factor() [2/2]

Glib::PropertyProxy_ReadOnly< double > Gtk::GestureLongPress::property_delay_factor | ( |  | ) | const

Factor by which to modify the default timeout.

Since gtkmm 3.20

Default value: 1.000000

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_delay_factor()

void Gtk::GestureLongPress::set_delay_factor | ( | double | delay_factor | ) |

Applies the given delay factor.

The default long press time will be multiplied by this value. Valid values are in the range [0.5..2.0].

Parameters

  delay_factor | The delay factor to apply.

## ◆ signal_cancelled()

Glib::SignalProxy< void()> Gtk::GestureLongPress::signal_cancelled | ( |  | ) |

Slot Prototype:
  void on_my_cancelled()

Flags: Run Last

Emitted whenever a press moved too far, or was released before signal_pressed() happened.

## ◆ signal_pressed()

Glib::SignalProxy< void(double, double)> Gtk::GestureLongPress::signal_pressed | ( |  | ) |

Slot Prototype:
  void on_my_pressed(double x, double y)

Flags: Run Last

Emitted whenever a press goes unmoved/unreleased longer than what the GTK defaults tell.

Parameters

  x | The X coordinate where the press happened, relative to the widget allocation.
  y | The Y coordinate where the press happened, relative to the widget allocation.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::GestureLongPress > wrap | ( | GtkGestureLongPress * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.